Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Rund um AutoCAD
  AutoLisp: Objekte zählen und Informationen abrufen

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   AutoLisp: Objekte zählen und Informationen abrufen (236 mal gelesen)
Karsten Moert
Mitglied


Sehen Sie sich das Profil von Karsten Moert an!   Senden Sie eine Private Message an Karsten Moert  Schreiben Sie einen Gästebucheintrag für Karsten Moert

Beiträge: 9
Registriert: 05.07.2020

AutoCAD 2013

erstellt am: 21. Jul. 2020 09:19    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


Baum.dxf

 
Guten Morgen,

meine Frage nach der Zählung von bestimmten Objekten innerhalb einer Umgrenzung wurde super beantwortet, jetzt möchte ich noch einen Schritt weiter gehen und zu den gezählten Objekten (als Beispiel Bäume) noch diverse Informationen abrufen. Allerdings reagiert mir AutoLisp anders als erwartet.
Im Anhang findet sich eine .dxf-Datei zum Testen (erstellt mit der 2020er-Studentenversion von AutoCad) und mein Code:

Code:
(Defun c:baum ()

(setq scmde (getvar "cmdecho"))
(setvar "cmdecho" 0)

(setq pkt nil oft 0)
(Print "Einen Umring auswählen")

(setq poly (ssget "_:S+." '((0 . "LWPOLYLINE"))))        ;Auswahl Polylinie
(sssetfirst (ssget "_P") (ssget "_P"))                    ;selektieren
(setq z 0)
(setq liste (entget(ssname poly 0)))
(setq lr (cdr liste))
(while lr
  (setq la (car lr))
  (setq art (car la))
  (if (= art 10) (setq pkt (cons (cdr la) pkt)))
  (setq lr (cdr lr))
)
(setq auswahl1 (ssget "_wp" pkt))
(if  auswahl1
  (progn
    (setq n (sslength auswahl1))
    (while (< z n)
      (setq liste1 (entget (ssname auswahl1 z)))
      (setq elemlayer (cdr (assoc 8 liste1)))
      (setq xx (caddr (assoc 10 liste1)))
      (setq yy (cadr (assoc 10 liste1)))
      (if (= elemlayer "Baum")
        ;(print (strcat (rtos xx 2 4) ", " (rtos yy 2 4)))
        (setq oft (+ 1 oft))
      )
      (setq z (+ 1 z))
    )
  )
)
(print (strcat (itoa oft) " Bäume innerhalb dieser Umgrenzung."))
(if (= oft 0) (acet-sys-beep 16) (acet-sys-beep 64))
(setvar "cmdecho" scmde)
(princ)
)


Der Code zählt die Bäume innerhalb einer Umgrenzung. Das funktioniert auch gut, sobald ich aber die auskommentierte Print-Anweisung durchführen lasse, erfolgt eine ganz falsche Zählung. In xx und yy sollen die Koordinaten ausgelesen werden und später in einer Datei gesammelt werden. So richtig erklären kann ich mir das nicht. Vermutlich wird Entget durch eine andere Liste gestört, ist das richtig. Wie müsste ich richtig vorgeben? Vielen Dank schon mal im Vorraus!

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 19924
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 21. Jul. 2020 09:31    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Karsten Moert 10 Unities + Antwort hilfreich

Lese noch mal nach wie IF funktioniert!

IF möchte einen Testausdruck, EINEN THEN-Ausdruck und optional einen else-Ausdruck bekommen.
Du hast in dem Code bereits PROGN genutzt, diese Funktion (siehe F1) kann bei der Lösung sehr hilfreich sein.


      (if (= elemlayer "Baum");Testausdruck
        (print (strcat (rtos xx 2 4) ", " (rtos yy 2 4)));THEN-Ausdruck
        (setq oft (+ 1 oft));else-Ausdruck
      )

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Karsten Moert
Mitglied


Sehen Sie sich das Profil von Karsten Moert an!   Senden Sie eine Private Message an Karsten Moert  Schreiben Sie einen Gästebucheintrag für Karsten Moert

Beiträge: 9
Registriert: 05.07.2020

AutoCAD 2013

erstellt am: 21. Jul. 2020 09:58    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Danke, cadffm!
Das wirft mich gleich auf die richtige Bahn. Die Zählung erfolgte also quasi nach dem ELSE, in anderen Programmsprachen ausgedrückt (frühe habe ich einige Basicdialekte und Assembler programmiert).
Ich wusste nie so richtig, wofür das PROGN ist, jetzt weiss ich es, danke dir! 

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 19924
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 21. Jul. 2020 10:10    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Karsten Moert 10 Unities + Antwort hilfreich

Wenn elemlayer = "Baum" (nicht BAUM oder baum, nur wenn Baum),
Dann führe (princ....) aus,
wenn es nicht zutrifft, dann zähle hoch (setq  oft...)

PROGN fasst Ausdrücke zusammen und gibt die letzte Auswertung zurück.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Karsten Moert
Mitglied


Sehen Sie sich das Profil von Karsten Moert an!   Senden Sie eine Private Message an Karsten Moert  Schreiben Sie einen Gästebucheintrag für Karsten Moert

Beiträge: 9
Registriert: 05.07.2020

AutoCAD 2013

erstellt am: 21. Jul. 2020 11:33    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Danke, das PRINT dient hier nur der schnellen Ausgabe / dem Debugging. Diese Werte möchte ich nachher in einer .csv-Datei speichern für simplen Excel-Import.
Wie müsste ich denn vorgeben, dass "Baum" oder "BAUM" oder "baum" gleich behandelt wird? Ah, verstanden:

Code:
(if (= (strcase elemlayer) "BAUM")

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2020 CAD.de | Impressum | Datenschutz